
import java.util.*;
import java.awt.*;

public class speechCANT23 extends CANT23{
  public static String ExperimentXMLFile = "speech.xml";
  public static speechNet nullNet;
  public static speechExperiment experiment; 
  public static int epoch = 1;
  public static int trainSuite = 1;
  public static int testSuite = 1;


  public static void main(String args[]){
System.out.println("initialize CANT Speech");
    seed = 25;
    initRandom();
    readNewSystem();
    connectAllNets();
    positionWindows();
    delayBetweenSteps=0;
  }
  
  private static void connectAllNets() {
    speechNet baseNet = (speechNet)experiment.getNet("BaseNet");
    speechNet phonemeNet = (speechNet)experiment.getNet("PhonemeNet");
	
    baseNet.connectBaseToPhoneme(phonemeNet);
  }

  protected static void readNewSystem() {
    nullNet = new speechNet();
	
    nets = NetManager.readNets(ExperimentXMLFile,nullNet);
    workerThread = new speechCANT23.WorkerThread();
    initializeExperiment();
    experiment.printExpName();
    speechNet net = (speechNet) experiment.getNet("BaseNet");
    workerThread.start();	
    //connectAllNets();	
  }
  
  //set up the experiment specific parameters.
  private static void initializeExperiment() {
    experiment = new speechExperiment();
    System.out.println("initialize Speech Experiment");
    experiment.printExpName();
  }
  
  public static void runOneStepStart() {
    if (experiment.trainingLength == CANTStep) experiment.switchToTest();
    if (experiment.getInTest()) experiment.measure(CANTStep);
  
    if (experiment.isEndEpoch(CANTStep)) experiment.endEpoch();
  }
  
  public static synchronized void runOneStep() {
    //runOneStepStart();

  if (experiment.experimentDone(CANTStep))  {
    System.out.println("experiment done "+seed);
    closeSystem();
    //numSystems++;
    epoch = 1;
    testSuite = 1;
    readNewSystem();
    connectAllNets();
    //makeNewSystem(numSystems);
    }

    Enumeration eNum = nets.elements();
    while (eNum.hasMoreElements()) {
      speechNet net = (speechNet)eNum.nextElement();
    if (net.getName().compareTo("BaseNet") == 0)
      {
      net.runAllOneStep(CANTStep); 
      CANTStep++;
      }
    }
   

  }
  
  
  private  static void positionWindows() {
    speechNet baseNet = (speechNet)experiment.getNet("BaseNet");
    speechNet phonemeNet = (speechNet)experiment.getNet("PhonemeNet");
  
    baseNet.cantFrame.setLocation(100,0);
    baseNet.cantFrame.setSize (500,400);
    baseNet.cantFrame.matrix.addStringsToPrint ("300Hz",30,150);
    baseNet.cantFrame.matrix.addStringsToPrint ("1000Hz",60);
    baseNet.cantFrame.matrix.addStringsToPrint ("2000Hz",90);
    baseNet.cantFrame.matrix.addStringsToPrint ("4000Hz",120);
    baseNet.cantFrame.show();

    phonemeNet.cantFrame.setLocation(300,400);
    phonemeNet.cantFrame.setSize (500,400);
    phonemeNet.cantFrame.matrix.addStringsToPrint ("Ah",30,150);
    phonemeNet.cantFrame.matrix.addStringsToPrint ("Ee",90);
    phonemeNet.cantFrame.matrix.addStringsToPrint ("Oo",150);
    phonemeNet.cantFrame.show();
  }
  
  //embedded Thread class
  public static class WorkerThread extends CANT23.WorkerThread{
    public void run(){
      System.out.println("Speech Thread ");
      while(true){
         if(isRunning){
           runOneStep();
         }
         else{
           try{sleep(delayBetweenSteps);}
		   catch(InterruptedException ie){ie.printStackTrace();}
             }//else
       }//while
    }//run
  }//WorkerThread class
  
}